/////////////////////////////////////////////////////////////////////////////////////////
// GS9 DEMO CONSOLE v2.2 080401
// Use: console.exe program_file
// Obs: program file must contain a main function
/////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <conio.h>
#include "gs.h"
#include "gslib_math.h"
#include "gslib_file.h"
#include "gslib_win.h"

/////////////////////////////////////////////////////////////////////////////////////////
extern	int yydebug;					// set to 1 for debugging parser; logs generated
		int g_debugvm = GSDBG_LOW;		// used for debuging errors in vm; read gserror.h

/////////////////////////////////////////////////////////////////////////////////////////
int CompileFile( char* file )
{
	guard(CompileFile)
	int ret;
	gsVM* vm = gs_init();
	vm->m_debug = g_debugvm;
	gslib_math(vm);
	gslib_file(vm);
	gslib_win(vm);
	ret = gs_compilefile(vm,file); 
	if(ret!=GS_OK) { gs_done(vm); return ret; }
	int fn = gs_findfn(vm,"main");
	if(fn==-1) { gs_done(vm); gslog("main() function not found.\n"); return GS_FAIL; }
	ret = gs_runfn(vm, fn, 0);
	gs_pop(vm);
	gs_done(vm); // returned value is on the stack but we ignore it since we destroy vm anyway
	return ret;
	unguard()
}

/////////////////////////////////////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
	guard(main)

	int ret;
	int flags = 0;

	gslog("GS9 %s %s\n",  GS_VER, GS_DATE);
	printf("----------------------------\n");

	// Config
	// yydebug = 1; // debug parser
	if(argc<2)
	{
		gslog("Use: console.exe program_file\n");
		gslog("     The program file must contain a main() function.\n");
		gslog("\n");
		getch();
		return 0;
	}

	ret = CompileFile(argv[1]);

	// report result
	printf("\n----------------------------\n");
	gslog("ERROR: %s\n",gs_nameerr(ret));
	getch();
	return 0;
}

